<?php

/**
 * Меню навигации
 */
class BlockNavigate extends Module
{
	function __construct()
	{
		$this->name = 'blocknavigate';
		$this->tab = 'Blocks';
		$this->version = 1.0;

		parent::__construct();

		$this->displayName = $this->l('Блок меню навигации');
		$this->description = $this->l('Добавляет верхнее, нижнее и левое меню навигации');
	}

	function install()
	{
		if (parent::install() == false
			OR $this->registerHook('Top') == false
                        OR $this->registerHook('leftColumn') == false
                        OR $this->registerHook('footer'))
			return false;
		return true;
	}

        function getTree($resultParents, $resultIds, $maxDepth=10, $id_category = 0, $currentDepth = 0)
	{
		global $link;

		$children = array();
		if (isset($resultParents[$id_category]) AND sizeof($resultParents[$id_category]))
			foreach ($resultParents[$id_category] as $subcat)
				$children[] = $this->getTree($resultParents, $resultIds, $maxDepth, $subcat['id_cms'], $currentDepth + 1);
		/*if (!isset($resultIds[$id_category]))
			return false;*/
		return array('id' => $id_category,
                             'link' => $link->getCMSLink($id_category, $resultIds[$id_category]['link_rewrite']),
                             'name' => Category::hideCategoryPosition($resultIds[$id_category]['page_title']),
                             'depth' => $currentDepth,
                             'link_rewrite'=> $resultIds[$id_category]['link_rewrite'],
                             'children' => $children
               );
	}
	
 	function hookTop($params)
        {
		global $smarty, $link, $cookie;
		
		$_pages=CMS::getLinksForMenu(1);

		$smarty->assign(array(
                    'pages' => $_pages,
                    'active_item'=> Tools::getValue('id_cms'),
                    'page_name' => substr($_SERVER['SCRIPT_NAME'],1,-4)
		));
		
		return $this->display(__FILE__, 'top.tpl');
	}

        function hookHome($params)
        {
            
		global $smarty, $link, $cookie;

		$_pages=CMS::getLinksForMenu(4, 3, false);
		$smarty->assign(array(
                    'pages' => $_pages
		));

		return $this->display(__FILE__, 'home.tpl');
	}

        function hookLeftColumn($params)
        {
		global $smarty, $cookie, $link, $cookie;

                if (!$result = Db::getInstance()->ExecuteS('
		SELECT cl.*
		FROM `'._DB_PREFIX_.'cms` c
                JOIN '._DB_PREFIX_.'menu_links l on l.cms_id= c.id_cms
		LEFT JOIN `'._DB_PREFIX_.'cms_lang` cl ON (c.`id_cms` = cl.`id_cms` AND `id_lang` = '.$cookie->id_lang.')
                WHERE l.menu_id=2 '
                .((!$cookie->isLogged())?" AND cl.authonly<>1":'').
		' ORDER BY `id_cms` ASC'))
                        return;

                if (isset($_GET['id_cms']))
		{
			$smarty->assign('currentPageId', intval($_GET['id_cms']));
		}

                $resultParents = array();
		$resultIds = array();

		foreach ($result as $row)
		{
			$row['name'] = Category::hideCategoryPosition($row['meta_title']);
			$resultParents[$row['parent_id']][] = $row;
			$resultIds[$row['id_cms']] = $row;
		}

                $blockMenuTree = $this->getTree($resultParents, $resultIds);

		$smarty->assign(array(
                    'blockMenuTree' => $blockMenuTree,
                    'active_item'=> Tools::getValue('id_cms'),
                    'page_name' => substr($_SERVER['SCRIPT_NAME'],1,-4),
                    'menu_branche_tpl_path' => _PS_MODULE_DIR_.'blocknavigate/menu-tree-branch.tpl'
		));

		return $this->display(__FILE__, 'left.tpl');
	}

        function hookFooter($params)
        {
		global $smarty, $link, $cookie;

		$_pages=CMS::getLinksForMenu(3);

		$smarty->assign(array(
                    'pages' => $_pages
		));

		return $this->display(__FILE__, 'footer.tpl');
	}
}
?>